#A*
Graph_nodes = {
    'A': [('B', 6), ('F', 3)],
    'B': [('A', 6), ('C', 3), ('D', 2)],
    'C': [('B', 3), ('D', 1)],
    'D': [('B', 2), ('C', 1), ('E', 8)],
    'E': [('D', 8), ('I', 5), ('J', 5)],
    'F': [('A', 3), ('G', 1), ('H', 7)],
    'G': [('F', 1), ('I', 3)],
    'H': [('F', 7), ('I', 2)],
    'I': [('E', 5), ('G', 3),('H', 2), ('J', 3)],
}

def get_neighbors(v):
    if v in Graph_nodes:
        return Graph_nodes[v]
    else:
        return None
        
def h(n):
    H_dist = {
        'A': 10,
        'B': 8,
        'C': 5,
        'D': 7,
        'E': 3,
        'F': 6,
        'G': 5,
        'H': 3,
        'I': 1,
        'J': 0 
    }
    return H_dist[n]
        
def aStarAlgo(start, stop):
    open = set(start)
    close = set()
    g = {}
    parents = {}
    g[start] = 0
    parents[start] = start

    while len(open) > 0:
        n = None

        for v in open:
            if n == None or g[v] + h(v) < g[n] + h(n):
                n = v

        if n == stop or Graph_nodes[n] == None:
            pass
        else:
            for (m, weight) in get_neighbors(n):
                if m not in open and m not in close:
                    open.add(m)
                    parents[m] = n
                    g[m] = g[n] + weight

                else:
                    if g[m] > g[n] + weight:
                        g[m] = g[n] + weight
                        parents[m] = n

                        if m in close:
                            close.remove(m)
                            open.add(m)

        if n == None:
            print('Path does not exist!')
            return None

        if n == stop:
            path = []

            while parents[n]!= n:
                path.append(n)
                n = parents[n]

            path.append(start)

            path.reverse()

            print('Path found: {}'.format(path))
            return path

        open.remove(n)
        close.add(n)

    print('Path does not exist!')
    return None

aStarAlgo('A', 'J')
